# Issues, Bug Reports, and Feature Requests

* When creating a new Issue, first search to see if it has already been filed.
* Bug reports must include the following or will be deleted:
    * Steps to reproduce.
    * Expected result.
    * Actual result.
    * Notes, log files, screen captures, videos, etc. to show the problem.

# Code Contributions and Pull Requests

Before starting work on a pull request, please read: https://github.com/openpnp/openpnp/wiki/Developers-Guide#contributing

Summary of guidelines:

* One pull request per issue, bug or feature.
* Describe the change in detail and why it is needed.
* Follow the coding style.
* Include tests and documentation.
* Run and pass the tests.
* Think of how this affects other users.


